
/*  *******************************************************************
    NOM:        PANTALLA.H
    CREAT PER:  Sergio Blanco Cuaresma
    		Francesc Galiano Baixauli
    DATA:       17/05/2001
    DESCRIPCIO: Rutines d'accs a pantalla en mode text 80x25.
    ******************************************************************* */



        /* Per impedir mltiples "inclusions" d'aquest fitxer capalera: */
#ifndef PANTALLA_H
#define PANTALLA_H

#include "tipus.h"    /* Definicions de tipus elementals: BYTE, WORD, ADR */

        /* Per a que funcioni tamb compilant en versi C++ */
#ifdef __cplusplus
extern "C" {
#endif



/***    Declaraci de FUNCIONS del mdul                      ***/


extern ADR IniPantalla (void);

        /* Retorna l'adrea de memria on est mapejada la pantalla. Emmagat-
           zema internament aquesta informaci per a que sigui usada per les
           rutines posteriors. En cas que el mode de pantalla no sigui reco-
           negut retorna el valor 0000:0000 que indica que s'ha produt un
           error. El valor retornat es pot utilitzar, a ms, per saber si es
           tracta d'un sistema color o monocrom. */


extern void EscriureCar (BYTE fila, BYTE columna, char caracter, BYTE atribut);

        /* Escriu a pantalla el carcter que se li passa, amb l'atribut
           indicat, a les coordenades especificades. La informaci d'on
           es troba mapejada la pantalla l'obt de la variable que ha
           inicialitzat la rutina IniPantalla(). */


extern void EscriureString (BYTE fila,BYTE columna,char * string,BYTE atribut);

        /* Escriu a pantalla la cadena de carcters que se li passa, a
           partir de la posici donada, i amb el mateix atribut per a tots
           els carcters. La seva implementaci pot utilitzar instruccions
           de tractament de strings de l'i8086 (LODSB i STOSW). La informa-
           ci d'on es troba mapejada la pantalla l'obt de la variable que
           ha inicialitzat la rutina IniPantalla(). */


extern void EsborrarPantalla (BYTE atribut);

        /* Omple tota la pantalla de carcters blancs (' ', espai, codi ASCII
           32) amb l'atribut que se li indica. Tamb es poden utilitzar ins-
           truccions de tractament de strings (concretament, REP STOSW). La
           informaci d'on es troba mapejada la pantalla l'obt de la variable
           que ha inicialitzat la rutina IniPantalla().*/


extern WORD QuinCarAtr (BYTE fila, BYTE columna);

        /* Accedeix a la posici de pantalla indicada i retorna la parella
           (carcter, atribut) que es troba en aquella posici, el carcter
           a la part baixa (LSB) del resultat i l'atribut a la part alta
           (MSB). La informaci d'on es troba mapejada la pantalla l'obt
           de la variable que ha inicialitzat la rutina IniPantalla(). */



#ifdef __cplusplus
}
#endif


#endif
